<?php
/*
* 2007-2011 PrestaShop 
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
* DISCLAIMER
*
* Do not edit or add to this file if you wish to upgrade PrestaShop to newer
* versions in the future. If you wish to customize PrestaShop for your
* needs please refer to http://www.prestashop.com for more information.
*
*  @author PrestaShop SA <contact@prestashop.com>
*  @copyright  2007-2011 PrestaShop SA
*  @version  Release: $Revision: 1.4 $
*  @license    http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
*  International Registered Trademark & Property of PrestaShop SA
*/

if (!defined('_CAN_LOAD_FILES_'))
	exit;
	
class BlockAdvertisingHome extends Module
{
	public $adv_link;

	public $adv_img;
	public $adv_link2;

	public $adv_img2;

	public $adv_imgname = 'advertising_custom1';
	public $adv_imgname2 = 'advertising_custom2';
	
	public function __construct()
	{
		$this->name = 'blockadvertisinghome';
		$this->tab = 'advertising_marketing';
		$this->version = 1.0;
		$this->author = 'DapurPixel';
		$this->need_instance = 1;

		parent::__construct();

		$this->displayName = $this->l('Block Advertising Home');
		$this->description = $this->l('Adds a block to display an advertisement in homepage.');

		$current_dir = defined('__DIR__')?__DIR__:dirname(__FILE__);
		if (!file_exists($current_dir.'/'.$this->adv_imgname.'.'.Configuration::get('BLOCKADVERT_IMG_EXT')))
			$this->adv_img = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/advertising_custom1.jpg';
		else
			$this->adv_img = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname.'.'.Configuration::get('BLOCKADVERT_IMG_EXT');
		$this->adv_link = htmlentities(Configuration::get('BLOCKADVERT_LINK'), ENT_QUOTES, 'UTF-8');
		
		
		
		if (!file_exists($current_dir.'/'.$this->adv_imgname2.'.'.Configuration::get('BLOCKADVERT_IMG_EXT2')))
			$this->adv_img2 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/advertising_custom2.jpg';
		else
			$this->adv_img2 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname2.'.'.Configuration::get('BLOCKADVERT_IMG_EXT');
		$this->adv_link2 = htmlentities(Configuration::get('BLOCKADVERT_LINK2'), ENT_QUOTES, 'UTF-8');
		
	}


	public function install()
	{
		Configuration::updateValue('BLOCKADVERT_LINK', 'http://www.dapurpixel.com');
		Configuration::updateValue('BLOCKADVERT_LINK2', 'http://www.dapurpixel.com');
		if (!parent::install() OR !$this->registerHook('home'))
			return false;
	}

	/**
	 * _deleteCurrentImg delete current image, (so this will use default image)
	 * 
	 * @return void
	 */
	private function _deleteCurrentImg()
	{
		// can work before 5.3
		$current_dir=defined(__DIR__)?__DIR__:dirname(__FILE__);

		if(file_exists($current_dir.'/'.$this->adv_imgname.'.'.Configuration::get('BLOCKADVERT_IMG_EXT')))
			unlink($current_dir.'/'.$this->adv_imgname.'.'.Configuration::get('BLOCKADVERT_IMG_EXT'));
	}
	
	private function _deleteCurrentImg2()
	{
		// can work before 5.3
		$current_dir=defined(__DIR__)?__DIR__:dirname(__FILE__);

		if(file_exists($current_dir.'/'.$this->adv_imgname2.'.'.Configuration::get('BLOCKADVERT_IMG_EXT2')))
			unlink($current_dir.'/'.$this->adv_imgname2.'.'.Configuration::get('BLOCKADVERT_IMG_EXT2'));
	}
	/**
	 * postProcess update configuration
	 * @TODO adding alt and title attributes for <img> and <a>
	 * @var string
	 * @return void
	 */
	public function postProcess()
	{
		global $currentIndex;

		$errors = '';
		if (Tools::isSubmit('submitDeleteImgConf'))
			$this->_deleteCurrentImg();	

		if (Tools::isSubmit('submitAdvConf'))
		{
			$file = false;
			if (isset($_FILES['adv_img']) AND isset($_FILES['adv_img']['tmp_name']) AND !empty($_FILES['adv_img']['tmp_name']))
			{
				if ($error = checkImage($_FILES['adv_img'], 4000000))
					$errors .= $error;
				elseif ($dot_pos = strrpos($_FILES['adv_img']['name'],'.'))
				{
					// __DIR__ exists since php 5.3
					$current_dir = defined(__DIR__)?__DIR__:dirname(__FILE__);
					// as checkImage tell us it's a good image, we'll just copy the extension
					$ext=substr($_FILES['adv_img']['name'], $dot_pos+1);
					$newname=$this->adv_imgname.'.'.$ext;

					$this->_deleteCurrentImg();

					if (!move_uploaded_file($_FILES['adv_img']['tmp_name'], $current_dir.'/'.$newname))
						$errors .= $this->l('Error move uploaded file');

					Configuration::updateValue('BLOCKADVERT_IMG_EXT',$ext);
					$this->adv_img = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname.'.'.Configuration::get('BLOCKADVERT_IMG_EXT');
				}
			}

			if ($link = Tools::getValue('adv_link'))
			{
				Configuration::updateValue('BLOCKADVERT_LINK', $link);
				$this->adv_link2 = htmlentities($link, ENT_QUOTES, 'UTF-8');
			}
		}
		
		
		
					
		if (Tools::isSubmit('submitDeleteImgConf2'))
			$this->_deleteCurrentImg2();	
			
		if (Tools::isSubmit('submitAdvConf2'))
		{
			$file = false;
			if (isset($_FILES['adv_img2']) AND isset($_FILES['adv_img2']['tmp_name']) AND !empty($_FILES['adv_img2']['tmp_name']))
			{
				if ($error = checkImage($_FILES['adv_img2'], 4000000))
					$errors .= $error;
				elseif ($dot_pos = strrpos($_FILES['adv_img2']['name'],'.'))
				{
					// __DIR__ exists since php 5.3
					$current_dir = defined(__DIR__)?__DIR__:dirname(__FILE__);
					// as checkImage tell us it's a good image, we'll just copy the extension
					$ext=substr($_FILES['adv_img2']['name'], $dot_pos+1);
					$newname=$this->adv_imgname2.'.'.$ext;

					$this->_deleteCurrentImg2();

					if (!move_uploaded_file($_FILES['adv_img2']['tmp_name'], $current_dir.'/'.$newname))
						$errors .= $this->l('Error move uploaded file');

					Configuration::updateValue('BLOCKADVERT_IMG_EXT2',$ext);
					$this->adv_img2 = Tools::getMediaServer($this->name)._MODULE_DIR_.$this->name.'/'.$this->adv_imgname2.'.'.Configuration::get('BLOCKADVERT_IMG_EXT2');
				}
			}

			if ($link = Tools::getValue('adv_link2'))
			{
				Configuration::updateValue('BLOCKADVERT_LINK2', $link);
				$this->adv_link2 = htmlentities($link, ENT_QUOTES, 'UTF-8');
			}
		}
		
		
		if ($errors)
			echo $this->displayError($errors);
	}

	/**
	 * getContent used to display admin module form
	 * 
	 * @return void
	 */
	public function getContent()
	{
		global $protocol_content;
		
		$this->postProcess();
		$output = '';
		$output .= '
<form action="'.$_SERVER['REQUEST_URI'].'" method="post" enctype="multipart/form-data">
<fieldset><legend>'.$this->l('Advertising block configuration').'</legend>
<a href="'.$this->adv_link.'" target="_blank" title="'.$this->l('Advertising').'">';
		if ($this->adv_img)
			$output .= '<img src="'.$protocol_content.$this->adv_img.'" alt="'.$this->l('Advertising image').'" style="height:80px;margin-left: 100px;width:306px"/>';
		else
			$output .= $this->l('no image');
		$output .= '</a>';
		if ($this->adv_img)
			$output .= '<input class="button" type="submit" name="submitDeleteImgConf" value="'.$this->l('Delete image').'" style=""/>';
		$output .= '<br/>
<br/>
<label for="adv_img">'.$this->l('Change image').'&nbsp;&nbsp;</label><input id="adv_img" type="file" name="adv_img" />
( '.$this->l('Image will be displayed as 306x80').' )
<br/>
<br class="clear"/>
<label for="adv_link">'.$this->l('Image link').'&nbsp;&nbsp;</label><input id="adv_link" type="text" name="adv_link" value="'.$this->adv_link.'" />
<br class="clear"/>
<br/>
<input class="button" type="submit" name="submitAdvConf" value="'.$this->l('validate').'" style="margin-left: 200px;"/>
</fieldset>
</form>




<br>
<form action="'.$_SERVER['REQUEST_URI'].'" method="post" enctype="multipart/form-data">
<fieldset>
<a href="'.$this->adv_link2.'" target="_blank" title="'.$this->l('Advertising').'">';
		if ($this->adv_img2)
			$output .= '<img src="'.$protocol_content.$this->adv_img2.'" alt="'.$this->l('Advertising image').'" style="height:80px;margin-left: 100px;width:306px"/>';
		else
			$output .= $this->l('no image');
		$output .= '</a>';
		if ($this->adv_img2)
			$output .= '<input class="button" type="submit" name="submitDeleteImgConf2" value="'.$this->l('Delete image').'" style=""/>';
		$output .= '<br/>
<br/>
<label for="adv_img2">'.$this->l('Change image').'&nbsp;&nbsp;</label><input id="adv_img2" type="file" name="adv_img2" />
( '.$this->l('Image will be displayed as 306x80').' )
<br/>
<br class="clear"/>
<label for="adv_link2">'.$this->l('Image link').'&nbsp;&nbsp;</label><input id="adv_link2" type="text" name="adv_link2" value="'.$this->adv_link2.'" />
<br class="clear"/>
<br/>
<input class="button" type="submit" name="submitAdvConf2" value="'.$this->l('validate').'" style="margin-left: 200px;"/>
</fieldset>
</form>
';
		return $output;
	}

	/**
	* Returns module content
	*
	* @param array $params Parameters
	* @return string Content
	*/
	function hookHome($params)
	{
		global $smarty, $protocol_content;

		Tools::addCSS(($this->_path).'blockadvertisinghome.css', 'all');
		$smarty->assign('image', $protocol_content.$this->adv_img);
		$smarty->assign('adv_link', $this->adv_link);
		$smarty->assign('image2', $protocol_content.$this->adv_img2);
		$smarty->assign('adv_link2', $this->adv_link2);

		return $this->display(__FILE__, 'blockadvertisinghome.tpl');
	}

}